// raul taranu

class AlphaBetaPlayer2 extends Player
{
	public static final int MAX_POSSIBLE = 24;
	public static final int INFINITY = 1000000;

	//constructor
	public AlphaBetaPlayer2(String name)
	{
		super(name);
		ruyLopez = new MovesList(10);
		setupRuyLopez();
		inRuyLopezOpening = true;
	}	
	
	private void setupRuyLopez()
	{
		ruyLopez.addMove(new Move(new Position(Position.E, 2), new Position(Position.E, 4)));
		ruyLopez.addMove(new Move(new Position(Position.E, 7), new Position(Position.E, 5)));
		ruyLopez.addMove(new Move(new Position(Position.G, 1), new Position(Position.F, 3)));
		ruyLopez.addMove(new Move(new Position(Position.B, 8), new Position(Position.C, 6)));
		ruyLopez.addMove(new Move(new Position(Position.F, 1), new Position(Position.B, 5)));
	}

	public Board makeMove(Board board, Chess gm)
	{
		Position from, to;
		if (board.getNumMoves() > 4)
			inRuyLopezOpening = false;
		if (inRuyLopezOpening)
		{
			Move move = ruyLopez.getMove(board.getNumMoves());
			from = move.getFrom();
			to = move.getTo();
			board.movePiece(move.getFrom(), move.getTo());
		}
		else
		{
			board.updateSuccessors();
			AlphaBetaSearch2 search  = new AlphaBetaSearch2(board, 1);
			Move move = search.getMove();
			from = move.getFrom();
			to = move.getTo();
			board.movePiece(move);
		}	
		
		return board;
	}

	//instance variables
	
	private MovesList ruyLopez;
	private boolean inRuyLopezOpening;
}