//raul taranu

public class AlphaBetaSearch2 
{
	private static final int INFINITY = 1000000;
    public AlphaBetaSearch2(Board board, int d) 
	{
    	utility = -INFINITY;
    	limit = d;
    	board.updateSuccessors();
    	alpha = -INFINITY;
    	beta = INFINITY;
    	MovesList moves = new MovesList(Board.MAX_SUCC);
    	for (int aSucc = 0; aSucc < board.getSuccessors().getNumSuccessors(); aSucc++)
	    {
	    	Successor currentSucc = board.getSuccessors().getSuccessor(aSucc);
	    	moves.addMove(new Move(currentSucc.getFrom(), currentSucc.getTo()));
	    }
    	
    	int temp;
    	Board succ;
	    succ = new Board(board);
	    succ.movePiece(moves.getMove(0));
	    move = moves.getMove(0);
	    utility = minValue(succ, 1);
	    //alpha = max(alpha, utility);
	    for (int aMove = 1; aMove < moves.getNumMoves(); aMove++)
	    {
	    	succ = new Board(board);
		    succ.movePiece(moves.getMove(0));
		    temp = minValue(succ, 1);
		    if (temp > utility)
		    {
		    	utility = temp;
		    	move = moves.getMove(aMove);
		    	//alpha = max(alpha, utility);
		    }		    
	    }
    }
    public Move getMove() { return move; }
    private boolean cutOff(Board state, int depth)
    {
    	return !state.noLoser() || depth == limit;
    }
    private int max(int a, int b)
    {
    	if (a > b)
    		return a;
    	else
    		return b;
    }
    private int min(int a, int b)
    {
    	if (a < b)
    		return a;
    	else
    		return b;
    }    
    private int maxValue(Board state, int depth)
    {
    	state.updateSuccessors();
    	if (cutOff(state, depth))
    		if (depth % 2 == 0)
    			return state.utility();
    		else 
    			return -state.utility();
    	int v = -INFINITY;
    	SuccessorsList successors = state.getSuccessors();
    	for (int s = 0; s < successors.getNumSuccessors(); s++)
    	{
    		Board succ = successors.getSuccessor(s).getBoard();
    		v = max(v, minValue(succ, depth + 1));
    		if (v >= beta)
    			return v;
    		alpha = max(alpha, v);
    	}
    	return v;    	
    }
    private int minValue(Board state, int depth)
    {
    	state.updateSuccessors();
    	if (cutOff(state, depth))
    		if (depth % 2 == 0)
    			return state.utility();
    		else
    			return -state.utility();
    	int v = INFINITY;
    	SuccessorsList successors = state.getSuccessors();
    	for (int s = 0; s < successors.getNumSuccessors(); s++)
    	{
    		Board succ = successors.getSuccessor(s).getBoard();
    		v = min(v, maxValue(succ, depth + 1));
    		if (v <= alpha)
    			return v;
    		beta = min(beta, v);
    	}
    	return v;
    }
    
    // instance variables
    private int limit;
    private int alpha;
    private int beta;
    private Move move;
    private int utility;
}