//raul taranu

class Bishop extends Piece
{
	//constructor
	public Bishop(int color)
	{
		super(color, Piece.BISHOP);
	}

	//accessors
	public void display()
	{
		switch (getColor())
		{
			case WHITE:
				System.out.print("White Bishop ");
				break;
			case BLACK:
				System.out.print("Black Bishop ");
				break;
		}
	}

	public PositionsList getAttackedPositions(Board board, Position startingPos)
	{
		PositionsList attacked = new PositionsList(Piece.MAX_MOVES);
		Position currentPos = startingPos;
		
		/* while not in first column, not in first row, and either in an empty position or the starting position */
		while (currentPos.getCol() > Position.A && currentPos.getRow() > 1 && (board.isEmpty(currentPos) || currentPos.equals(startingPos)))
		{
			/* move diagonally down and left */
			currentPos = new Position(currentPos.getCol() - 1, currentPos.getRow() - 1);
			attacked.addPosition(currentPos);
		}
		
		currentPos = startingPos; /* reset current position to starting position */
		
		/* while not in first column, not in last row, and either in an empty position or the starting position */
		while (currentPos.getCol() > Position.A && currentPos.getRow() < 8 && (board.isEmpty(currentPos) || currentPos.equals(startingPos)))
		{
			/* move diagonally down and right */
			currentPos = new Position(currentPos.getCol() - 1, currentPos.getRow() + 1);
			attacked.addPosition(currentPos);
		}
		
		currentPos = startingPos; /* reset current position to starting position */
		
		/* while not in last column, not in first row, and either in an empty position or the starting position */
		while (currentPos.getCol() < Position.H && currentPos.getRow() > 1 && (board.isEmpty(currentPos) || currentPos.equals(startingPos)))
		{
			/* move diagonally up and left */
			currentPos = new Position(currentPos.getCol() + 1, currentPos.getRow() - 1);
			attacked.addPosition(currentPos);
		}
		
		currentPos = startingPos; /* reset current position to starting position */
		
		/* while not in last column, not in last row, and either in an empty position or the starting position */
		while (currentPos.getCol() < Position.H && currentPos.getRow() < 8 && (board.isEmpty(currentPos) || currentPos.equals(startingPos)))
		{
			/* move diagonally up and right */
			currentPos = new Position(currentPos.getCol() + 1, currentPos.getRow() + 1);
			attacked.addPosition(currentPos);
		}
		currentPos = null;
		return attacked;
	}
}