import javax.swing.*;
import java.awt.event.*;

class BoardPanel extends JPanel implements ActionListener
{
	public BoardPanel(Chess gm)
	{
		super();
		this.gm = gm;
	}
	
	public void addBoardButtons()
	{
		Board board = gm.getBoard();
		
		for (int row = Board.NUM_ROWS - 2; row >= 0; row--)
		{
			for (int col = 0; col < Board.NUM_COLS - 1; col++)
			{	
				PositionButton pb = new PositionButton(board.getPosition(col + 1, row + 1));
				pb.addActionListener(this);
				add(pb);
			}
		}
	}
	
	public void update()
	{
		removeAll();
		
		addBoardButtons();
				
		validate();
		repaint();
	}
	
	public void actionPerformed (ActionEvent e)
	{
		PositionButton pb = (PositionButton)(e.getSource());
		position = pb.getPosition();
		//pb.setEnabled(false);
		gm.killThread();
	}
	
	public Position getPosition ()
	{
		return position;
	}
		
	private Position position;
	private Chess gm;
}