// raul taranu

import java.net.*;
import java.io.*;

class Chess extends Thread
{
	public static void main(String[] str)
	{
		while (true)
		{
			Chess gameManager = new Chess("Chess");
			gameManager.playOneGame();
		}
	}

	//constructor
	public Chess(String gameName)
	{
		server = null;
		client = null;
		socket = null;
		in = null;
		out = null;
		newGame = false;
		board = new Board();
		table = new Table(gameName, this);
		//board.display();
		System.out.print("\n");
		game = table.getGameType();
		if (game.equals("local"))
		{
			white = table.getPlayer("White");
			black = table.getPlayer("Black");
		}
		else
			if (game.equals("join"))
			{
				listenSocket();
				white = new NetworkPlayer("White");
				black = new HumanPlayer("Black");
			}
			else
			{
				serveSocket();
				white = new HumanPlayer("White");
				black = new NetworkPlayer("Black");
			}

	}

	public void playOneGame()
	{
		while (board.noLoser() && !board.stalemate() && !newGame)
		{
			board = white.makeMove(board, this);
			table.update();
//			try
//			{
//				sleep(2000);
//			}
//			catch (InterruptedException e)
//			{}
			if (board.noLoser() && !board.stalemate())
			{
				board = black.makeMove(board, this);
				table.update();
//				try
//				{
//					sleep(2000);
//				}
//				catch (InterruptedException e)
//				{}
			}
		}
		if (!board.noLoser())
		{
			table.dialog("Checkmate!!");
			table.setVisible(false);
		}
		else
			if (board.stalemate())
			{
				table.dialog("Stalemate!!");
				table.setVisible(false);
			}
	}

	public void newGame()
	{
		newGame = true;
	}

	public Position waitForPos()
	{
		waiter = new GUIWaiter();
		waiter.start();
		try
		{
			waiter.join();
		}
		catch (InterruptedException e)
		{}
		return table.getPosition();
	}

	public Board getBoard()
	{
		return board;
	}

	public Table getTable()
	{
		return table;
	}

	public void killThread()
	{
		waiter.setDone();
	}

	public void serveSocket()
	{
		try
		{
			server = new ServerSocket(4444);
		}
		catch (IOException e)
		{
			System.out.println("Could not listen on port 4444");
			System.exit(-1);
		}

		try
		{
			client = server.accept();
			table.dialog("Connection Established\nPlease make a move.");
		}
		catch (IOException e)
		{
			System.out.println("Accept failed: 4444");
			System.exit(-1);
		}

		try
		{
			in = new BufferedReader(new InputStreamReader(client.getInputStream()));
			out = new PrintWriter(client.getOutputStream(), true);
		}
		catch (IOException e)
		{
			System.out.println("Accept failed: 4444");
			System.exit(-1);
		}
	}

	public void listenSocket()
	{
		//		Create socket connection
		try
		{
			socket = new Socket(table.getHostIP(), 4444);
			out = new PrintWriter(socket.getOutputStream(), true);
			in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
		}
		catch (UnknownHostException e)
		{
			System.out.println("Unknown host: " + table.getHostIP());
			System.exit(1);
		}
		catch (IOException e)
		{
			System.out.println("No I/O");
			System.exit(1);
		}
	}

	public Position waitForNetPos()
	{
		//System.out.print("col: " + inCol + ", row: " + inRow + "\n");
		try
		{
			//System.out.println("receiving");
			inCol = in.readLine();
			inRow = in.readLine();
//			System.out.println("received col: " + inCol);
//			System.out.println("received row: " + inRow);
		}
		catch (IOException e)
		{
			System.out.println("Read failed");
			System.exit(-1);
		}
		return new Position(inCol, inRow);
	}

	protected void finalize()
	{
		//		Clean up
		try
		{
			in.close();
			out.close();
			server.close();
		}
		catch (IOException e)
		{
			System.out.println("Could not close.");
			System.exit(-1);
		}
	}

	public void sendPosition(String col, String row)
	{
		if (out != null)
		{
			out.println(col);
			out.println(row);
		}
	}

	//instance variables
	//private Player [] player;
	private Table table;

	private GUIWaiter waiter;

	private Board board;

	private Player white;

	private Player black;

	private boolean newGame;

	private String game, outFCol, outFRow, outTCol, outTRow, inCol, inRow;

	private ServerSocket server;

	private Socket client;

	private Socket socket;

	private BufferedReader in;

	private PrintWriter out;

	private Board inBoard;
}