// raul taranu

class HumanPlayer extends Player
{
	//constructor
	public HumanPlayer(String name)
	{
		super(name);
	}
	
	private boolean validMove(Board board, Position from, Position to, Chess gm)
	{
		if (board.getPiece(from) == null || board.getPiece(from).getColor() != board.nextMove())
		{
			gm.getTable().dialog("Please move one of your pieces.");
			return false;
		}
		else if (from.equals(to))
		{
			gm.getTable().dialog("No move made.");
			return false;
		}
		else 
		{
			CapturesList caps = board.getPiece(from).getCaptures(board, from);
			PositionsList moves = board.getPiece(from).getMoves(board, from);
			if (!moves.member(to) && !caps.member(to))
			{
				gm.getTable().dialog("That is not a legal move.");
				return false;
			}
		}
		return true;
	}
	
	public void updateOutPositions(Position pos, Chess gm)
	{
		String col = null;
		String row = null;
		switch (pos.getCol())
		{
			case Position.A:
				col = "A";
				break;
			case Position.B:
				col = "B";
				break;
			case Position.C:
				col = "C";
				break;
			case Position.D:
				col = "D";
				break;
			case Position.E:
				col = "E";
				break;
			case Position.F:
				col = "F";
				break;
			case Position.G:
				col = "G";
				break;
			case Position.H:
				col = "H";
				break;
		}
		
		switch (pos.getRow())
		{
			case 1:
				row = "1";
				break;
			case 2:
				row = "2";
				break;
			case 3:
				row = "3";
				break;
			case 4:
				row = "4";
				break;
			case 5:
				row = "5";
				break;
			case 6:
				row = "6";
				break;
			case 7:
				row = "7";
				break;
			case 8:
				row = "8";
				break;
		}
		gm.sendPosition(col, row);
	}

	public Board makeMove(Board board, Chess gm)
	{
		Position from;
		Position to;
		do
		{
			from = gm.waitForPos();
			to = gm.waitForPos();
		}
		while (!validMove(board, from, to, gm));
		updateOutPositions(from, gm);
		updateOutPositions(to, gm);
				
		board.movePiece(from, to);
		return board;
	}

	//instance variables
}