// raul taranu

class King extends Piece
{
	//constructor
	public King(int color)
	{
		super(color, Piece.KING);
	}

	//accessors
	public void display()
	{
		switch (getColor())
		{
			case WHITE:
				System.out.print("White King   ");
				break;
			case BLACK:
				System.out.print("Black King   ");
				break;
		}
	}
	
	public boolean checkmate(Board board, Position position)
	{
		PositionsList team;
		Position currentPos;
		if (getColor() == Piece.WHITE)
			team = board.getWhitePositions();
		else
			team = board.getBlackPositions();
		
		if ((getMoves(board, position).getNumPositions() == 0) && 
				(getCaptures(board, position).getNumPositions() == 0) && 
				inCheck(board, position))
		{			
			PositionsList attackers = position.getAttackers(board, getColor());
			if (attackers.getNumPositions() > 1)
				return true;
			else // only one attacker
			{
				for (int aPos = 0; aPos < team.getNumPositions(); aPos++)
				{
					currentPos = team.getPosition(aPos);
					if (currentPos.getPiece().getCaptures(board, currentPos).member(attackers.getPosition(0)))
						return false;
				}
				if (board.canBlockCheck(position, attackers.getPosition(0)))
					return false;
				else 
					return true;
			}
		}
		else
			return false;
	}
	
	public boolean inCheck(Board board, Position position)
	{
		return position.isAttacked(board, getColor());
	}

	public PositionsList getAttackedPositions(Board board, Position startingPos)
	{
		PositionsList attacked = new PositionsList(Piece.MAX_MOVES);
		Position currentPos = startingPos;

		if (currentPos.getCol() > Position.A && currentPos.getRow() > 1)
		{
			/* move left and down */
			currentPos = new Position(currentPos.getCol() - 1,
					currentPos.getRow() - 1);
			attacked.addPosition(currentPos);
		}
		currentPos = startingPos;
		if (currentPos.getCol() > Position.A && currentPos.getRow() < 8)
		{
			/* move left and up */
			currentPos = new Position(currentPos.getCol() - 1,
					currentPos.getRow() + 1);
			attacked.addPosition(currentPos);
		}
		currentPos = startingPos;
		if (currentPos.getCol() < Position.H && currentPos.getRow() > 1)
		{
			/* move right and down */
			currentPos = new Position(currentPos.getCol() + 1,
					currentPos.getRow() - 1);
			attacked.addPosition(currentPos);
		}
		currentPos = startingPos;
		if (currentPos.getCol() < Position.H && currentPos.getRow() < 8)
		{
			/* move left and up */
			currentPos = new Position(currentPos.getCol() + 1,
					currentPos.getRow() + 1);
			attacked.addPosition(currentPos);
		}
		currentPos = startingPos;
		if (currentPos.getCol() > Position.A)
		{
			/* move left */
			currentPos = new Position(currentPos.getCol() - 1, currentPos.getRow());
			attacked.addPosition(currentPos);
		}
		currentPos = startingPos;
		if (currentPos.getCol() < Position.H)
		{
			/* move right */
			currentPos = new Position(currentPos.getCol() + 1, currentPos.getRow());
			attacked.addPosition(currentPos);
		}
		currentPos = startingPos;
		if (currentPos.getRow() > 1)
		{
			/* move down */
			currentPos = new Position(currentPos.getCol(), currentPos.getRow() - 1);
			attacked.addPosition(currentPos);
		}
		currentPos = startingPos;
		if (currentPos.getRow() < 8)
		{
			/* move up */
			currentPos = new Position(currentPos.getCol(), currentPos.getRow() + 1);
			attacked.addPosition(currentPos);
		}
		currentPos = null;
		return attacked;
	}
}