//raul taranu

public class MiniMaxSearch
{
	public static final int MIN = 0;
	public static final int MAX = 1;
    public MiniMaxSearch(int d) 
	{
    	limit = d;
    }
    
    public int minimax(Board state, int player, int depth)
    {
    	Board next;
    	int val;
    	if (depth == limit || !state.noLoser())
    	{
    		if (depth % 2 == 0)
    		{
    			return state.utility();
    		}
    		else 
    		{
    			return -state.utility();
    		}
    	}
    	state.updateSuccessors();
    	SuccessorsList successors = state.getSuccessors();
    	MovesList moves = new MovesList(Board.MAX_SUCC);
    	for (int aSucc = 0; aSucc < successors.getNumSuccessors(); aSucc++)
	    {
	    	Successor currentSucc = successors.getSuccessor(aSucc);
	    	moves.addMove(new Move(currentSucc.getFrom(), currentSucc.getTo()));
	    }
    	if (player == MIN)
    	{
    		int count = 0;
    		int minValue = Integer.MAX_VALUE;
    		while (moves.getNumMoves() > count)
			{
    		    next = new Board(state);
    		    next.movePiece(moves.getMove(count));
    			count++;
    	    	val = minimax(next, MAX, depth+1);
    	    	minValue = Math.min(val,minValue);
			}
    		return minValue;
    	}
    	else // (player == MAX)
        {
    		int count = 0;
    		int maxValue = -Integer.MAX_VALUE;
    		while (moves.getNumMoves() > count)
			{
    			next = new Board(state);
    		    next.movePiece(moves.getMove(count));
    			count++;
    			val = minimax(next, MIN, depth+1);
    			maxValue = Math.max(val,maxValue);
			}
			return maxValue;
        }
    }
    // instance variables
    private int limit;
}