//raul taranu

class Pawn extends Piece
{
	//constructor
	public Pawn(int color)
	{	
		super(color, Piece.PAWN);
	}
	
	//accessors
	public void display()
	{
		switch (getColor())
		{
			case WHITE: System.out.print("White Pawn   ");break;
			case BLACK: System.out.print("Black Pawn   ");break;
		}
	}
	
	public PositionsList getAttackedPositions(Board board, Position startingPos)
	{	
		PositionsList attacked = new PositionsList(Piece.MAX_MOVES);
		Position currentPos = startingPos;
		
		if (getColor() == WHITE)
		{
			if (startingPos.getRow() < 8)
			{
				if (startingPos.getCol() > Position.A)
				{
					Position leftDiag = new Position(startingPos.getCol() - 1, startingPos.getRow() + 1);
					attacked.addPosition(leftDiag);
					leftDiag = null;
				}
				if (startingPos.getCol() < Position.H)
				{
					Position rightDiag = new Position(startingPos.getCol() + 1, startingPos.getRow() + 1);
					attacked.addPosition(rightDiag);
					rightDiag = null;
				}
			}
		}
		
		else //color is BLACK
		{
			if (startingPos.getRow() > 1)
			{
				if (startingPos.getCol() > Position.A)
				{
					Position rightDiag = new Position(startingPos.getCol() - 1, startingPos.getRow() - 1);
					attacked.addPosition(rightDiag);
					rightDiag = null;
				}
				if (startingPos.getCol() < Position.H)
				{
					Position leftDiag = new Position(startingPos.getCol() + 1, startingPos.getRow() - 1);
					attacked.addPosition(leftDiag);
					leftDiag = null;
				}
			}
		}
		
		return attacked;
	}
		
	public PositionsList getMoves(Board board, Position startingPos)
	{
		PositionsList moves = new PositionsList(Piece.MAX_MOVES);
		int color = board.getPiece(startingPos).getColor();
		Board copy;
		King kingPiece = new King(color);
		Position kingPosition;
		
		if (color == Piece.WHITE)
		{
			if (startingPos.getRow() < 8)
			{	
				Position forwardOne = new Position(startingPos.getCol(), startingPos.getRow() + 1);
				copy = new Board(board);
				copy.movePiece(startingPos, forwardOne);
				kingPosition = copy.getKingPos(color);
				if (board.isEmpty(forwardOne) && !kingPiece.inCheck(copy, kingPosition))
				{
					moves.addPosition(forwardOne);					
					if (startingPos.getRow() == 2)
					{
						Position forwardTwo = new Position(startingPos.getCol(), startingPos.getRow() + 2);
						copy = new Board(board);
						copy.movePiece(startingPos, forwardTwo);
						kingPosition = copy.getKingPos(color);
						if (board.isEmpty(forwardTwo) && !kingPiece.inCheck(copy, kingPosition))
							moves.addPosition(forwardTwo);
					}
				}
				copy = null;
			}
		}
			
		else
		{
			if (startingPos.getRow() > 1)
			{
				Position forwardOne = new Position(startingPos.getCol(), startingPos.getRow() - 1);
				copy = new Board(board);
				copy.movePiece(startingPos, forwardOne);
				kingPosition = copy.getKingPos(color);
				if (board.isEmpty(forwardOne) && !kingPiece.inCheck(copy, kingPosition))
				{
					moves.addPosition(forwardOne);					
					if (startingPos.getRow() == 7)
					{
						Position forwardTwo = new Position(startingPos.getCol(), startingPos.getRow() - 2);
						copy = new Board(board);
						copy.movePiece(startingPos, forwardTwo);
						kingPosition = copy.getKingPos(color);
						if (board.isEmpty(forwardTwo) && !kingPiece.inCheck(copy, kingPosition))
							moves.addPosition(forwardTwo);
					}
				}
				copy = null;
			}
		}
		kingPiece = null;
		return moves;
	}
}