//raul taranu

class Queen extends Piece
{
	//constructor
	public Queen(int color)
	{	
		super(color, Piece.QUEEN);
	}
	
	//accessors
	public void display()
	{
		switch (getColor())
		{
			case WHITE: System.out.print("White Queen  ");break;
			case BLACK: System.out.print("Black Queen  ");break;
		}
	}
	
	public PositionsList getAttackedPositions(Board board, Position startingPos)
	{
		PositionsList attacked = new PositionsList(Piece.MAX_MOVES);
		Position currentPos = startingPos;
		
		/* while not in first column, not in first row, and either in an empty position or the starting position */
		while (currentPos.getCol() > Position.A && currentPos.getRow() > 1 && (board.isEmpty(currentPos) || currentPos.equals(startingPos)))
		{
			/* move diagonally down and left */
			currentPos = new Position(currentPos.getCol() - 1, currentPos.getRow() - 1);
			attacked.addPosition(currentPos);
		}
		
		currentPos = startingPos; /* reset current position to starting position */
		
		/* while not in first column, not in last row, and either in an empty position or the starting position */
		while (currentPos.getCol() > Position.A && currentPos.getRow() < 8 && (board.isEmpty(currentPos) || currentPos.equals(startingPos)))
		{
			/* move diagonally down and right */
			currentPos = new Position(currentPos.getCol() - 1, currentPos.getRow() + 1);
			attacked.addPosition(currentPos);
		}
		
		currentPos = startingPos; /* reset current position to starting position */
		
		/* while not in last column, not in first row, and either in an empty position or the starting position */
		while (currentPos.getCol() < Position.H && currentPos.getRow() > 1 && (board.isEmpty(currentPos) || currentPos.equals(startingPos)))
		{
			/* move diagonally up and left */
			currentPos = new Position(currentPos.getCol() + 1, currentPos.getRow() - 1);
			attacked.addPosition(currentPos);
		}
		
		currentPos = startingPos; /* reset current position to starting position */
		
		/* while not in last column, not in last row, and either in an empty position or the starting position */
		while (currentPos.getCol() < Position.H && currentPos.getRow() < 8 && (board.isEmpty(currentPos) || currentPos.equals(startingPos)))
		{
			/* move diagonally up and right */
			currentPos = new Position(currentPos.getCol() + 1, currentPos.getRow() + 1);
			attacked.addPosition(currentPos);
		}
		
		currentPos = startingPos; /* reset current position to starting position */
		
		/* while not in first column, and either in an empty position or the starting position */
		while (currentPos.getCol() > Position.A && (board.isEmpty(currentPos) || currentPos.equals(startingPos)))
		{
			/* move left */
			currentPos = new Position(currentPos.getCol() - 1, currentPos.getRow());
			attacked.addPosition(currentPos);
		}
		
		currentPos = startingPos; /* reset current position to starting position */
		
		/* while not in last column, and either in an empty position or the starting position */
		while (currentPos.getCol() < Position.H && (board.isEmpty(currentPos) || currentPos.equals(startingPos)))
		{
			/* move right */
			currentPos = new Position(currentPos.getCol() + 1, currentPos.getRow());
			attacked.addPosition(currentPos);
		}
		
		currentPos = startingPos; /* reset current position to starting position */
		
		/* while not in first row, and either in an empty position or the starting position */
		while (currentPos.getRow() > 1 && (board.isEmpty(currentPos) || currentPos.equals(startingPos)))
		{
			/* move down */
			currentPos = new Position(currentPos.getCol(), currentPos.getRow() - 1);
			attacked.addPosition(currentPos);
		}
		
		currentPos = startingPos; /* reset current position to starting position */
		
		/* while not in last row, and either in an empty position or the starting position */
		while (currentPos.getRow() < 8 && (board.isEmpty(currentPos) || currentPos.equals(startingPos)))
		{
			/* move up */
			currentPos = new Position(currentPos.getCol(), currentPos.getRow() + 1);
			attacked.addPosition(currentPos);
		}
		return attacked;
	}
}