// raul taranu

class SuccessorsList
{
	//constructor
	public SuccessorsList(int maxSuccessors)
	{
		successors = new Successor[maxSuccessors];
		numSuccessors = 0;
	}
	
	public SuccessorsList(SuccessorsList aList)
	{
		Successor currentSuccessor;
		this.successors = new Successor[aList.getNumSuccessors()];
		this.numSuccessors = 0;
		for (int aSucc = 0; aSucc < aList.getNumSuccessors(); aSucc++)
		{
			currentSuccessor = aList.getSuccessor(aSucc);
			addSuccessor(currentSuccessor.getBoard(), currentSuccessor.getFrom(), currentSuccessor.getTo());
		}
	}

	//accessors
	public boolean isEmpty()
	{
		return (getNumSuccessors() == 0);
	}

	public int getNumSuccessors()
	{
		return numSuccessors;
	}

	public Successor getSuccessor(int succNumber)
	{
		return successors[succNumber];
	}

	public boolean member(Board successor)
	{
		for (int aSucc = 0; aSucc < getNumSuccessors(); aSucc++)
		{
			if (getSuccessor(aSucc).equals(successor))
				return true;
		}
		return false;
	}

	//output
	
	//mutators
	public void incrementNumSuccessors()
	{
		numSuccessors++;
	}

	public void addSuccessor(Board board, Position from, Position to)
	{
		successors[getNumSuccessors()] = new Successor(board, from, to);
		incrementNumSuccessors();
	}

	//instance variables
	private Successor[] successors;
	private int numSuccessors;
}